Index: trunk/src/VBox/ValidationKit/utils/fs/FsPerf.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/fs/FsPerf.cpp	(revision 76795)
+++ trunk/src/VBox/ValidationKit/utils/fs/FsPerf.cpp	(revision 76796)
@@ -58,5 +58,5 @@
  * Always does an even number of iterations.
  */
-#define PROFILE_FN(a_fnCall, a_cNsTarget, a_szDesc1, a_szDesc2) \
+#define PROFILE_FN(a_fnCall, a_cNsTarget, a_szDesc) \
     do { \
         /* Estimate how many iterations we need to fill up the given timeslot: */ \
@@ -78,7 +78,5 @@
         } \
         uint64_t const cNsElapsed = RTTimeNanoTS() - nsStart; \
-        if (a_szDesc1 != NULL) \
-            RTTestIValueF(cNsElapsed, RTTESTUNIT_NS, a_szDesc1, cIterations); \
-        RTTestIValueF(cNsElapsed / cIterations, RTTESTUNIT_NS_PER_OCCURRENCE, a_szDesc2); \
+        RTTestIValueF(cNsElapsed / cIterations, RTTESTUNIT_NS_PER_OCCURRENCE, a_szDesc); \
     } while (0)
 
@@ -416,6 +414,6 @@
     RTTESTI_CHECK_RC(RTFileClose(hFile1), VINF_SUCCESS);
 
-    PROFILE_FN(fsPerfOpenExistingOnceReadonly(g_szDir),  g_nsTestRun, NULL, "RTFileOpen/Close/Readonly");
-    PROFILE_FN(fsPerfOpenExistingOnceWriteonly(g_szDir), g_nsTestRun, NULL, "RTFileOpen/Close/Writeonly");
+    PROFILE_FN(fsPerfOpenExistingOnceReadonly(g_szDir),  g_nsTestRun, "RTFileOpen/Close/Readonly");
+    PROFILE_FN(fsPerfOpenExistingOnceWriteonly(g_szDir), g_nsTestRun, "RTFileOpen/Close/Writeonly");
 
     /*
@@ -425,6 +423,6 @@
                                      RTFILE_O_CREATE | RTFILE_O_DENY_NONE | RTFILE_O_WRITE), VINF_SUCCESS);
     RTTESTI_CHECK_RC(RTFileClose(hFile1), VINF_SUCCESS);
-    PROFILE_FN(fsPerfOpenExistingOnceReadonly(g_szDeepDir),  g_nsTestRun, NULL, "RTFileOpen/Close/deep/readonly");
-    PROFILE_FN(fsPerfOpenExistingOnceWriteonly(g_szDeepDir), g_nsTestRun, NULL, "RTFileOpen/Close/deep/writeonly");
+    PROFILE_FN(fsPerfOpenExistingOnceReadonly(g_szDeepDir),  g_nsTestRun, "RTFileOpen/Close/deep/readonly");
+    PROFILE_FN(fsPerfOpenExistingOnceWriteonly(g_szDeepDir), g_nsTestRun, "RTFileOpen/Close/deep/writeonly");
 
     /* Manytree: */
@@ -441,6 +439,6 @@
                                      RTFILE_O_CREATE_REPLACE | RTFILE_O_DENY_NONE | RTFILE_O_WRITE), VINF_SUCCESS);
     RTFSOBJINFO ObjInfo = {0};
-    PROFILE_FN(RTFileQueryInfo(hFile1, &ObjInfo,  RTFSOBJATTRADD_NOTHING), g_nsTestRun, NULL, "RTFileQueryInfo/NOTHING");
-    PROFILE_FN(RTFileQueryInfo(hFile1, &ObjInfo,  RTFSOBJATTRADD_UNIX),    g_nsTestRun, NULL, "RTFileQueryInfo/UNIX");
+    PROFILE_FN(RTFileQueryInfo(hFile1, &ObjInfo,  RTFSOBJATTRADD_NOTHING), g_nsTestRun, "RTFileQueryInfo/NOTHING");
+    PROFILE_FN(RTFileQueryInfo(hFile1, &ObjInfo,  RTFSOBJATTRADD_UNIX),    g_nsTestRun, "RTFileQueryInfo/UNIX");
 
     RTTESTI_CHECK_RC(RTFileClose(hFile1), VINF_SUCCESS);
@@ -458,5 +456,5 @@
     RTFMODE const fEvenMode = (ObjInfo.Attr.fMode & ~RTFS_UNIX_ALL_ACCESS_PERMS) | RTFS_DOS_READONLY   | 0400;
     RTFMODE const fOddMode  = (ObjInfo.Attr.fMode & ~(RTFS_UNIX_ALL_ACCESS_PERMS | RTFS_DOS_READONLY)) | 0640;
-    PROFILE_FN(RTFileSetMode(hFile1, iIteration & 1 ? fOddMode : fEvenMode), g_nsTestRun, NULL, "RTFileSetMode");
+    PROFILE_FN(RTFileSetMode(hFile1, iIteration & 1 ? fOddMode : fEvenMode), g_nsTestRun, "RTFileSetMode");
 
     RTFileSetMode(hFile1, ObjInfo.Attr.fMode);
@@ -494,5 +492,5 @@
 
     /* Benchmark it: */
-    PROFILE_FN(RTFileSetTimes(hFile1, NULL, iIteration & 1 ? &Time1 : &Time2, NULL, NULL), g_nsTestRun, NULL, "RTFileSetTimes");
+    PROFILE_FN(RTFileSetTimes(hFile1, NULL, iIteration & 1 ? &Time1 : &Time2, NULL, NULL), g_nsTestRun, "RTFileSetTimes");
 
     RTTESTI_CHECK_RC(RTFileClose(hFile1), VINF_SUCCESS);
@@ -518,7 +516,7 @@
 
     PROFILE_FN(RTPathQueryInfoEx(g_szDir, &ObjInfo,  RTFSOBJATTRADD_NOTHING,  RTPATH_F_ON_LINK), g_nsTestRun,
-               NULL, "RTPathQueryInfoEx/NOTHING");
+               "RTPathQueryInfoEx/NOTHING");
     PROFILE_FN(RTPathQueryInfoEx(g_szDir, &ObjInfo,  RTFSOBJATTRADD_UNIX,     RTPATH_F_ON_LINK), g_nsTestRun,
-               NULL, "RTPathQueryInfoEx/UNIX");
+               "RTPathQueryInfoEx/UNIX");
 
 
@@ -529,7 +527,7 @@
 
     PROFILE_FN(RTPathQueryInfoEx(g_szDeepDir, &ObjInfo,  RTFSOBJATTRADD_NOTHING, RTPATH_F_ON_LINK), g_nsTestRun,
-               NULL, "RTPathQueryInfoEx/deep/NOTHING");
+               "RTPathQueryInfoEx/deep/NOTHING");
     PROFILE_FN(RTPathQueryInfoEx(g_szDeepDir, &ObjInfo,  RTFSOBJATTRADD_UNIX, RTPATH_F_ON_LINK), g_nsTestRun,
-               NULL, "RTPathQueryInfoEx/deep/UNIX");
+               "RTPathQueryInfoEx/deep/UNIX");
 
     /* Manytree: */
@@ -562,5 +560,5 @@
     RTFMODE const fEvenMode = (ObjInfo.Attr.fMode & ~RTFS_UNIX_ALL_ACCESS_PERMS) | RTFS_DOS_READONLY   | 0400;
     RTFMODE const fOddMode  = (ObjInfo.Attr.fMode & ~(RTFS_UNIX_ALL_ACCESS_PERMS | RTFS_DOS_READONLY)) | 0640;
-    PROFILE_FN(RTPathSetMode(g_szDir, iIteration & 1 ? fOddMode : fEvenMode), g_nsTestRun, NULL, "RTPathSetMode");
+    PROFILE_FN(RTPathSetMode(g_szDir, iIteration & 1 ? fOddMode : fEvenMode), g_nsTestRun, "RTPathSetMode");
     RTPathSetMode(g_szDir, ObjInfo.Attr.fMode);
 
@@ -570,5 +568,5 @@
     RTTESTI_CHECK_RC(RTFileClose(hFile1), VINF_SUCCESS);
 
-    PROFILE_FN(RTPathSetMode(g_szDeepDir, iIteration & 1 ? fOddMode : fEvenMode), g_nsTestRun, NULL, "RTPathSetMode/deep");
+    PROFILE_FN(RTPathSetMode(g_szDeepDir, iIteration & 1 ? fOddMode : fEvenMode), g_nsTestRun, "RTPathSetMode/deep");
     RTPathSetMode(g_szDeepDir, ObjInfo.Attr.fMode);
 
@@ -623,5 +621,5 @@
     PROFILE_FN(RTPathSetTimesEx(g_szDir, iIteration & 1 ? &Time1 : &Time2, iIteration & 1 ? &Time2 : &Time1,
                                 NULL, NULL, RTPATH_F_ON_LINK),
-               g_nsTestRun, NULL, "RTPathSetTimesEx");
+               g_nsTestRun, "RTPathSetTimesEx");
 
     /* Deep: */
@@ -632,5 +630,5 @@
     PROFILE_FN(RTPathSetTimesEx(g_szDeepDir, iIteration & 1 ? &Time1 : &Time2, iIteration & 1 ? &Time2 : &Time1,
                                 NULL, NULL, RTPATH_F_ON_LINK),
-               g_nsTestRun, NULL, "RTPathSetTimesEx/deep");
+               g_nsTestRun, "RTPathSetTimesEx/deep");
 
     /* Manytree: */
@@ -674,6 +672,5 @@
     /* Shallow: */
     strcat(strcpy(szPath, g_szDir), "-other");
-    PROFILE_FN(RTPathRename(iIteration & 1 ? szPath : g_szDir, iIteration & 1 ? g_szDir : szPath, 0),
-               g_nsTestRun, NULL, "RTPathRename");
+    PROFILE_FN(RTPathRename(iIteration & 1 ? szPath : g_szDir, iIteration & 1 ? g_szDir : szPath, 0), g_nsTestRun, "RTPathRename");
 
     /* Deep: */
@@ -684,5 +681,5 @@
     strcat(strcpy(szPath, g_szDeepDir), "-other");
     PROFILE_FN(RTPathRename(iIteration & 1 ? szPath : g_szDeepDir, iIteration & 1 ? g_szDeepDir : szPath, 0),
-               g_nsTestRun, NULL, "RTPathRename/deep");
+               g_nsTestRun, "RTPathRename/deep");
 
     /* Manytree: */
@@ -817,7 +814,6 @@
      * Profile.
      */
-    PROFILE_FN(fsPerfEnumEmpty(), g_nsTestRun, NULL, "RTDirOpen/Read/Close empty");
-    PROFILE_FN(fsPerfEnumManyFiles(), g_nsTestRun, NULL, "RTDirOpen/Read/Close manyfiles");
-
+    PROFILE_FN(fsPerfEnumEmpty(), g_nsTestRun, "RTDirOpen/Read/Close empty");
+    PROFILE_FN(fsPerfEnumManyFiles(), g_nsTestRun, "RTDirOpen/Read/Close manyfiles");
 }
 