Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_bg.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_bg.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_bg.ts	(revision 76824)
@@ -16686,4 +16686,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca.ts	(revision 76824)
@@ -8998,4 +8998,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca_VA.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca_VA.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca_VA.ts	(revision 76824)
@@ -16708,4 +16708,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_cs.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_cs.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_cs.ts	(revision 76824)
@@ -16966,4 +16966,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_da.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_da.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_da.ts	(revision 76824)
@@ -10426,4 +10426,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 76824)
@@ -11375,4 +11375,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_el.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_el.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_el.ts	(revision 76824)
@@ -11373,4 +11373,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts	(revision 76824)
@@ -17767,4 +17767,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_eu.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_eu.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_eu.ts	(revision 76824)
@@ -677,5 +677,5 @@
     </message>
     <message>
-        <location filename="../src/globals/UIActionPoolManager.cpp" line="+857"/>
+        <location filename="../src/globals/UIActionPoolManager.cpp" line="+866"/>
         <location filename="../src/globals/UIActionPoolRuntime.cpp" line="-1643"/>
         <source>&amp;Network</source>
@@ -926,5 +926,5 @@
     </message>
     <message>
-        <location filename="../src/globals/UIActionPoolManager.cpp" line="-1449"/>
+        <location filename="../src/globals/UIActionPoolManager.cpp" line="-1458"/>
         <location filename="../src/globals/UIActionPoolRuntime.cpp" line="-870"/>
         <source>&amp;Settings...</source>
@@ -1626,16 +1626,16 @@
     <message>
         <location line="+72"/>
-        <location line="+1050"/>
+        <location line="+1059"/>
         <source>Clone selected virtual machine</source>
         <translation>Klonatu hautaturiko makina birtuala</translation>
     </message>
     <message>
-        <location line="-1023"/>
-        <location line="+1182"/>
+        <location line="-1032"/>
+        <location line="+1191"/>
         <source>&amp;Move...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location line="-1181"/>
+        <location line="-1190"/>
         <source>Move selected virtual machine</source>
         <translation type="unfinished"></translation>
@@ -1743,10 +1743,10 @@
     <message>
         <location line="+33"/>
-        <location line="+2163"/>
+        <location line="+2172"/>
         <source>Import</source>
         <translation type="unfinished">Inportatu</translation>
     </message>
     <message>
-        <location line="-1181"/>
+        <location line="-1190"/>
         <location filename="../src/globals/UIActionPoolRuntime.cpp" line="-572"/>
         <source>&amp;Detach GUI</source>
@@ -1765,5 +1765,5 @@
     </message>
     <message>
-        <location line="+29"/>
+        <location line="+32"/>
         <source>&amp;Details</source>
         <translation type="unfinished">&amp;Xehetasunak</translation>
@@ -1775,10 +1775,10 @@
     </message>
     <message>
-        <location line="+29"/>
+        <location line="+32"/>
         <source>&amp;Snapshots</source>
         <translation type="unfinished">&amp;Berehalakoak</translation>
     </message>
     <message>
-        <location line="-144"/>
+        <location line="-150"/>
         <source>Save state of selected virtual machines</source>
         <translation>Gorde makina birtualaren makina egoera</translation>
@@ -1846,10 +1846,10 @@
     </message>
     <message>
-        <location line="+61"/>
+        <location line="+67"/>
         <source>Open the machine snapshots pane</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location line="+29"/>
+        <location line="+32"/>
         <source>&amp;Logs</source>
         <translation type="unfinished"></translation>
@@ -2291,5 +2291,5 @@
     </message>
     <message>
-        <location line="-1946"/>
+        <location line="-1955"/>
         <source>&amp;New...</source>
         <translation>&amp;Berria...</translation>
@@ -2306,5 +2306,5 @@
     <message>
         <location line="+481"/>
-        <location line="+1224"/>
+        <location line="+1233"/>
         <source>&amp;Add...</source>
         <translation>&amp;Gehitu...</translation>
@@ -2315,5 +2315,5 @@
     </message>
     <message>
-        <location line="-1122"/>
+        <location line="-1131"/>
         <source>Cl&amp;one...</source>
         <translation>Kl&amp;onatu...</translation>
@@ -2325,5 +2325,5 @@
     <message>
         <location line="+58"/>
-        <location line="+1196"/>
+        <location line="+1205"/>
         <location line="+237"/>
         <source>&amp;Remove...</source>
@@ -2331,5 +2331,5 @@
     </message>
     <message>
-        <location line="-1432"/>
+        <location line="-1441"/>
         <source>Remove selected virtual machines</source>
         <translation>Kendu hautaturiko makina birtualak</translation>
@@ -5470,5 +5470,5 @@
     </message>
     <message>
-        <location filename="../src/globals/VBoxGlobal.cpp" line="+2762"/>
+        <location filename="../src/globals/VBoxGlobal.cpp" line="+2767"/>
         <location filename="../src/settings/global/UIGlobalSettingsExtension.cpp" line="+88"/>
         <source>Extensions</source>
@@ -15197,5 +15197,5 @@
     <name>UIVisoCreator</name>
     <message>
-        <location filename="../src/medium/viso/UIVisoContentBrowser.cpp" line="+185"/>
+        <location filename="../src/medium/viso/UIVisoContentBrowser.cpp" line="+248"/>
         <source>VISO content</source>
         <translation type="unfinished"></translation>
@@ -15222,5 +15222,5 @@
     </message>
     <message>
-        <location line="+6"/>
+        <location line="+5"/>
         <source>Name</source>
         <translation type="unfinished">Izena</translation>
@@ -15257,5 +15257,5 @@
     </message>
     <message>
-        <location filename="../src/medium/viso/UIVisoCreator.cpp" line="+72"/>
+        <location filename="../src/medium/viso/UIVisoCreator.cpp" line="+77"/>
         <source>&amp;Configuration...</source>
         <translation type="unfinished"></translation>
@@ -15292,5 +15292,5 @@
     </message>
     <message>
-        <location filename="../src/medium/viso/UIVisoHostBrowser.cpp" line="+101"/>
+        <location filename="../src/medium/viso/UIVisoHostBrowser.cpp" line="+135"/>
         <source>Host file system</source>
         <translation type="unfinished"></translation>
@@ -15302,6 +15302,11 @@
     </message>
     <message>
-        <location filename="../src/medium/viso/UIVisoConfigurationDialog.cpp" line="+69"/>
+        <location filename="../src/medium/viso/UIVisoConfigurationDialog.cpp" line="+82"/>
         <source>VISO Name:</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location line="+11"/>
+        <source>Custom VISO options:</source>
         <translation type="unfinished"></translation>
     </message>
@@ -17820,5 +17825,5 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/globals/VBoxGlobal.cpp" line="-2446"/>
+        <location filename="../src/globals/VBoxGlobal.cpp" line="-2451"/>
         <source>%n year(s)</source>
         <translation>
@@ -17972,5 +17977,5 @@
     </message>
     <message>
-        <location filename="../src/globals/VBoxGlobal.cpp" line="+2249"/>
+        <location filename="../src/globals/VBoxGlobal.cpp" line="+2254"/>
         <source>Unknown device</source>
         <comment>USB device details</comment>
@@ -17993,5 +17998,5 @@
     </message>
     <message>
-        <location line="-616"/>
+        <location line="-621"/>
         <source>Please choose a virtual hard disk file</source>
         <translation>Mesedez hautatu diska gogor agiri birtual bat</translation>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fa.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fa.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fa.ts	(revision 76824)
@@ -13597,4 +13597,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts	(revision 76824)
@@ -13574,4 +13574,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts	(revision 76824)
@@ -15591,4 +15591,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_gl.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_gl.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_gl.ts	(revision 76824)
@@ -13374,4 +13374,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_he.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_he.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_he.ts	(revision 76824)
@@ -10429,4 +10429,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hr_HR.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hr_HR.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hr_HR.ts	(revision 76824)
@@ -10598,4 +10598,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts	(revision 76824)
@@ -16820,4 +16820,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_id.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_id.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_id.ts	(revision 76824)
@@ -16181,4 +16181,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts	(revision 76824)
@@ -18630,4 +18630,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts	(revision 76824)
@@ -17429,4 +17429,8 @@
     <message>
         <source>Add selected file objects to ISO</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>Custom VISO options:</source>
         <translation type="unfinished"></translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_km_KH.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_km_KH.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_km_KH.ts	(revision 76824)
@@ -13262,4 +13262,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts	(revision 76824)
@@ -17197,4 +17197,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_lt.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_lt.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_lt.ts	(revision 76824)
@@ -15284,4 +15284,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_nl.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_nl.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_nl.ts	(revision 76824)
@@ -11345,4 +11345,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts	(revision 76824)
@@ -15561,4 +15561,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt.ts	(revision 76824)
@@ -14265,4 +14265,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts	(revision 76824)
@@ -18282,4 +18282,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts	(revision 76824)
@@ -13919,4 +13919,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 76824)
@@ -17193,4 +17193,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sk.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sk.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sk.ts	(revision 76824)
@@ -13897,4 +13897,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sl.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sl.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sl.ts	(revision 76824)
@@ -943,10 +943,10 @@
     <message>
         <location line="+33"/>
-        <location line="+2163"/>
+        <location line="+2172"/>
         <source>Import</source>
         <translation type="unfinished">Uvozi</translation>
     </message>
     <message>
-        <location line="-2162"/>
+        <location line="-2171"/>
         <source>&amp;Import Appliance...</source>
         <translation>&amp;Uvozi namensko napravo …</translation>
@@ -1004,10 +1004,10 @@
     <message>
         <location line="+36"/>
-        <location line="+1224"/>
+        <location line="+1233"/>
         <source>&amp;Add...</source>
         <translation>&amp;Dodaj …</translation>
     </message>
     <message>
-        <location line="-1122"/>
+        <location line="-1131"/>
         <source>Cl&amp;one...</source>
         <translation>&amp;Kloniraj …</translation>
@@ -1015,5 +1015,5 @@
     <message>
         <location line="+58"/>
-        <location line="+1196"/>
+        <location line="+1205"/>
         <location line="+237"/>
         <source>&amp;Remove...</source>
@@ -1021,5 +1021,5 @@
     </message>
     <message>
-        <location line="-1181"/>
+        <location line="-1190"/>
         <source>Discard</source>
         <translation>Zavrzi</translation>
@@ -1486,5 +1486,5 @@
     </message>
     <message>
-        <location filename="../src/globals/UIActionPoolManager.cpp" line="+885"/>
+        <location filename="../src/globals/UIActionPoolManager.cpp" line="+894"/>
         <location filename="../src/globals/UIActionPoolRuntime.cpp" line="-1643"/>
         <source>&amp;Network</source>
@@ -1570,5 +1570,5 @@
     </message>
     <message>
-        <location filename="../src/globals/UIActionPoolManager.cpp" line="-1726"/>
+        <location filename="../src/globals/UIActionPoolManager.cpp" line="-1735"/>
         <location line="+176"/>
         <source>Create new virtual machine</source>
@@ -1614,16 +1614,16 @@
     <message>
         <location line="+72"/>
-        <location line="+1050"/>
+        <location line="+1059"/>
         <source>Clone selected virtual machine</source>
         <translation>Kloniraj izbran navidezni računalnik</translation>
     </message>
     <message>
-        <location line="-1023"/>
-        <location line="+1182"/>
+        <location line="-1032"/>
+        <location line="+1191"/>
         <source>&amp;Move...</source>
         <translation type="unfinished">&amp;Premakni …</translation>
     </message>
     <message>
-        <location line="-1181"/>
+        <location line="-1190"/>
         <source>Move selected virtual machine</source>
         <translation type="unfinished"></translation>
@@ -1746,5 +1746,5 @@
     </message>
     <message>
-        <location line="+90"/>
+        <location line="+99"/>
         <source>&amp;Logs</source>
         <translation type="unfinished"></translation>
@@ -2136,5 +2136,5 @@
     </message>
     <message>
-        <location line="-1721"/>
+        <location line="-1730"/>
         <source>Sort group of first selected virtual machine alphabetically</source>
         <translation>Razvrsti skupino prvo izbranega navideznega računalnika po abecedi</translation>
@@ -2158,5 +2158,5 @@
     </message>
     <message>
-        <location line="+29"/>
+        <location line="+32"/>
         <source>&amp;Details</source>
         <translation>&amp;Podrobnosti</translation>
@@ -2168,5 +2168,5 @@
     </message>
     <message>
-        <location line="+29"/>
+        <location line="+32"/>
         <source>&amp;Snapshots</source>
         <translation>&amp;Posnetki stanja</translation>
@@ -2186,5 +2186,5 @@
     </message>
     <message>
-        <location line="+58"/>
+        <location line="+61"/>
         <source>&amp;Global Tools Menu</source>
         <translation>Meni &amp;splošnih orodij</translation>
@@ -2216,5 +2216,5 @@
     </message>
     <message>
-        <location line="-264"/>
+        <location line="-273"/>
         <source>Save state of selected virtual machines</source>
         <translation>Shrani stanje izbranih navideznih računalnikov</translation>
@@ -4853,5 +4853,5 @@
     </message>
     <message>
-        <location filename="../src/globals/VBoxGlobal.cpp" line="+2762"/>
+        <location filename="../src/globals/VBoxGlobal.cpp" line="+2767"/>
         <location filename="../src/settings/global/UIGlobalSettingsExtension.cpp" line="+88"/>
         <source>Extensions</source>
@@ -13591,5 +13591,5 @@
     <name>UIVisoCreator</name>
     <message>
-        <location filename="../src/medium/viso/UIVisoContentBrowser.cpp" line="+185"/>
+        <location filename="../src/medium/viso/UIVisoContentBrowser.cpp" line="+248"/>
         <source>VISO content</source>
         <translation type="unfinished"></translation>
@@ -13616,5 +13616,5 @@
     </message>
     <message>
-        <location line="+6"/>
+        <location line="+5"/>
         <source>Name</source>
         <translation type="unfinished">Ime</translation>
@@ -13651,5 +13651,5 @@
     </message>
     <message>
-        <location filename="../src/medium/viso/UIVisoCreator.cpp" line="+72"/>
+        <location filename="../src/medium/viso/UIVisoCreator.cpp" line="+77"/>
         <source>&amp;Configuration...</source>
         <translation type="unfinished"></translation>
@@ -13686,5 +13686,5 @@
     </message>
     <message>
-        <location filename="../src/medium/viso/UIVisoHostBrowser.cpp" line="+101"/>
+        <location filename="../src/medium/viso/UIVisoHostBrowser.cpp" line="+135"/>
         <source>Host file system</source>
         <translation type="unfinished"></translation>
@@ -13696,6 +13696,11 @@
     </message>
     <message>
-        <location filename="../src/medium/viso/UIVisoConfigurationDialog.cpp" line="+69"/>
+        <location filename="../src/medium/viso/UIVisoConfigurationDialog.cpp" line="+82"/>
         <source>VISO Name:</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location line="+11"/>
+        <source>Custom VISO options:</source>
         <translation type="unfinished"></translation>
     </message>
@@ -15827,5 +15832,5 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/globals/VBoxGlobal.cpp" line="-2446"/>
+        <location filename="../src/globals/VBoxGlobal.cpp" line="-2451"/>
         <source>%n year(s)</source>
         <translation>
@@ -15972,5 +15977,5 @@
     </message>
     <message>
-        <location filename="../src/globals/VBoxGlobal.cpp" line="+2249"/>
+        <location filename="../src/globals/VBoxGlobal.cpp" line="+2254"/>
         <source>Unknown device</source>
         <comment>USB device details</comment>
@@ -15993,5 +15998,5 @@
     </message>
     <message>
-        <location line="-565"/>
+        <location line="-570"/>
         <source>All files (*)</source>
         <translation>Vse datoteke (*)</translation>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sr.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sr.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sr.ts	(revision 76824)
@@ -15089,4 +15089,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts	(revision 76824)
@@ -16757,4 +16757,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_th.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_th.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_th.ts	(revision 76824)
@@ -10863,4 +10863,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_tr.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_tr.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_tr.ts	(revision 76824)
@@ -16710,4 +16710,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_uk.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_uk.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_uk.ts	(revision 76824)
@@ -16094,4 +16094,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts	(revision 76824)
@@ -8963,4 +8963,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts	(revision 76824)
@@ -15320,4 +15320,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts	(revision 76823)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts	(revision 76824)
@@ -8991,4 +8991,8 @@
         <translation type="unfinished"></translation>
     </message>
+    <message>
+        <source>Custom VISO options:</source>
+        <translation type="unfinished"></translation>
+    </message>
 </context>
 <context>